<template>
  <v-popover
    :trigger="mergedOptions.trigger"
    :open="mergedOptions.open"
    :placement="mergedOptions.placement"
    :offset="mergedOptions.offset"
    :popover-base-class="baseClasses"
    :enabled="mergedOptions.enabled"
    :container="mergedOptions.container"
    @apply-hide="$emit('apply-hide')"
    popover-arrow-class="tooltip-arrow"
    popover-class=""
    popover-inner-class="tooltip-inner"
    popover-wrapper-class="">
    <slot name="tooltip-trigger"/>
    <template #popover>
      <slot name="tooltip-content"/>
    </template>
  </v-popover>
</template>

<script>
export default {
  name: 'AppPopover',
  props: {
    options: {
      type: Object,
      default() {
        return {};
      },
    },
  },

  data() {
    return {
      defaultOptions: {
        trigger: 'hover',
        open: false,
        placement: 'bottom',
        offset: 4,
        baseClass: 'tooltip',
        enabled: true,
        container: 'body',
        additionalClasses: [],
      },
    };
  },
  computed: {
    mergedOptions() {
      return Object.assign({}, this.defaultOptions, this.options);
    },
    baseClasses() {
      const classes = [this.mergedOptions.baseClass];
      classes.push(...this.mergedOptions.additionalClasses);

      return classes;
    },
  },
};
</script>

<style lang="postcss">
  .tooltip {
    position: absolute;
    z-index: var(--z-index-over-modal);
    display: block;


    font-size: 0.75rem;
    line-height: 1.4;
    font-weight: var(--font-weight-regular);
    color: var(--color-main);
    text-align: left;
    white-space: normal;

    background-color: var(--bg-main);
    border: 1px solid var(--border-color-light);
    border-radius: 0.25rem;


    &-arrow {
      position: absolute;
      z-index: 1;
      margin: 0.3125rem;
      width: 0;
      height: 0;
    }

    .paragraph {
      font-size: inherit;
      color: inherit;
    }

    .paragraph + .paragraph {
      padding-top: 0.375rem;
    }

    .button {
      margin-top: 0.625rem;
      padding: 0 0.625rem;
      min-width: 3rem;
      min-height: 1.875rem;
      height: 1.875rem;
      font-size: 0.75rem;
      font-weight: var(--font-weight-bold);

      &.buttonOutline {
        color: var(--color-on-dark-light);
        border: 1px solid var(--border-color-dark);
        font-weight: var(--font-weight-regular);
        background-color: transparent;
        transition: border-color 0.1s var(--transition-easeOutQuad);

        &:hover {
          color: var(--color-on-dark-dark);
          border-color: var(--color-main-lighten);
        }

        &:active, &:focus {
          color: var(--color-on-dark-lighten);
          border-color: var(--color-on-dark-darken);
        }

      }
    }
  }

  .tooltipDark {
    padding: 0.3125rem 0.625rem;
    color: var(--bg-main);
    border: none;
    background-color: var(--bg-tooltip-dark);

    .tooltip-arrow {
      border-style: solid;
      border-color: var(--bg-tooltip-dark);
    }

    &[x-placement^="top"] {
      margin-bottom: 0.3125rem;

      .tooltip-arrow {
        border-width: 0.3125rem 0.3125rem 0 0.3125rem;
        border-left-color: transparent !important;
        border-right-color: transparent !important;
        border-bottom-color: transparent !important;
        bottom: -0.3125rem;
        left: calc(50% - 0.3125rem);
        margin-top: 0;
        margin-bottom: 0;
      }
    }

    &[x-placement^="bottom"] {
      margin-top: 0.3125rem;

      .tooltip-arrow {
        border-width: 0 0.3125rem 0.3125rem 0.3125rem;
        border-left-color: transparent !important;
        border-right-color: transparent !important;
        border-top-color: transparent !important;
        top: -0.3125rem;
        left: calc(50% - 0.3125rem);
        margin-top: 0;
        margin-bottom: 0;
      }
    }

    &[x-placement^="right"] {
      margin-left: 0.3125rem;

      .tooltip-arrow {
        border-width: 0.3125rem 0.3125rem 0.3125rem 0;
        border-left-color: transparent !important;
        border-top-color: transparent !important;
        border-bottom-color: transparent !important;
        left: -0.3125rem;
        top: calc(50% - 0.3125rem);
        margin-left: 0;
        margin-right: 0;
      }
    }

    &[x-placement^="left"] {
      margin-right: 0.3125rem;

      .tooltip-arrow {
        border-width: 0.3125rem 0 0.3125rem 0.3125rem;
        border-top-color: transparent !important;
        border-right-color: transparent !important;
        border-bottom-color: transparent !important;
        right: -0.3125rem;
        top: calc(50% - 0.3125rem);
        margin-left: 0;
        margin-right: 0;
      }
    }
  }

  .tooltipWhite {
    padding: 1rem;
    box-shadow: 3px 3px 1px rgba(0, 0, 0, 0.1);

    .tooltip-arrow {
        border: none;

        &:after, &:before {
          position: absolute;
          content: " ";
          height: 0;
          width: 0;
          border-style: solid;
          border-color: transparent;
        }

        &:after {
          border-color: transparent;
          border-width: 6px;
          margin-left: -6px;
        }

        &:before {
          border-color: transparent;
          border-width: 7px;
          margin-left: -7px;
        }
      }

    &[x-placement^="left"] {
      .tooltip-arrow {
        right: -12px;
        &:after {
          left: 100%;
          margin-top: -7px;
          border-width: 7px;
          margin-left: -7px;
          border-left-color: var(--bg-main);
        }
        &:before {
          left: 100%;
          margin-top: -7px;
          border-width: 7px;
          margin-left: -6px;
          border-left-color: var(--border-color-light);
        }
      }
    }

    &[x-placement^="right"] {
      .tooltip-arrow {
        left: -12px;
        &:after {
          right: 100%;
          margin-top: -7px;
          border-width: 7px;
          margin-right: -7px;
          border-right-color: var(--bg-main);
        }
        &:before {
          left: 100%;
          margin-top: -7px;
          border-width: 7px;
          margin-left: -8px;
          border-right-color: var(--border-color-light);
        }
      }
    }

    &[x-placement^="bottom"] {
        .tooltip-arrow {
          top: -5px;

          &:after {
            left: 50%;
            bottom: 100%;
            border-bottom-color: var(--bg-main);
          }

          &:before {
            left: 50%;
            bottom: 100%;
            border-bottom-color: var(--border-color-light);
          }
        }
      }

    &[x-placement^="bottom-end"] {
        .tooltip-arrow {
          top: -5px;
        }
      }

    &[x-placement^="top"] {
        .tooltip-arrow {
          bottom: -5px;

          &:after {
            left: 50%;
            top: 100%;
            border-top-color: var(--bg-main);
          }

          &:before {
            left: 50%;
            top: 100%;
            border-top-color: var(--border-color-light);
          }
        }
      }
  }

  .tooltipCallHelper {
    width: 14rem;
    .link {
      padding-top: 1rem;
    }
    .tooltip-close {
      position: absolute;
      top: -1rem;
      right: -1rem;
      display: flex;
      justify-content: center;
      align-items: center;
      width: 2.5rem;
      height: 2.5rem;
      background: none;
      border: none;
      outline: none;
      cursor: pointer;

      .svg {
        display: block;
        width: 0.625rem;
        height: 0.625rem;
        fill: var(--fill-light);
      }

      &:hover, &:active, &:focus {
        .svg {
          fill: var(--fill-main);
        }
      }
    }
  }

  .tooltipChatNoLogin {
    padding: 1rem;
    width: 20rem;
  }

  .tooltipLocation {
    padding: 0.625rem 0.75rem;
    text-align: center;

    .paragraph {
      padding-bottom: 0.5rem;
    }
  }

  .tooltipAddPrice {
    padding: 0.625rem 0.75rem;
    .button {
      margin-top: 0.5rem;
      + .button {
        margin-left: 1rem;
      }
    }
  }

  .tooltipFeedback {
    padding: 0.625rem 0.75rem;
  }

  @media screen and (max-width: 980px) {
    .tooltip {
      font-size: 0.875rem;

      &-text {
        display: block;
        padding-bottom: 0.875rem;
        font-size: 1rem;
      }

      .button {
        margin: 0 0.5rem;
        padding: 0 1.5rem;
        height: var(--btn-mobile-min-height);
        font-size: 1rem;
      }

      &.tooltip.tooltipAddPrice {
        position: fixed !important;
        top: auto !important;
        bottom: 0;
        right: 0;
        margin: 0;
        padding: 1.125rem 1.125rem 0;
        width: 100vw;
        text-align: center;
        border-radius: 0;
        transform: none !important;
        .tooltip-arrow {
          display: none;
        }
        .button {
          margin-bottom: 1.125rem;
        }
      }

      &.tooltipLocation {
        position: fixed !important;
        top: auto !important;
        bottom: 0;
        right: 0;
        margin: 0;
        padding: 1.125rem;
        width: 100vw;
        text-align: center;
        border-radius: 0;
        transform: none !important;
        .tooltip-arrow {
          display: none;
        }
      }

      &.tooltipCallHelper {
        position: fixed !important;
        top: auto !important;
        bottom: 0;
        right: 0;
        margin: 0;
        padding: 0;
        width: 100vw;
        min-width: 20rem;
        border-radius: 0;
        box-shadow: none;
        transform: none !important;

        .tooltip-inner {
          padding: 1.125rem 5rem 1.25rem 1.25rem;
        }

        .tooltip-arrow {
          display: none;
        }

        .tooltip-close {
          top: 0;
          right: 0;
          width: 3.75rem;
          height: 3.75rem;

          .svg {
            width: 1.25rem;
            height: 1.25rem;
          }
        }

        .link {
          font-size: 1rem;
        }

        .paragraph {
          font-size: 1rem;

          &:first-of-type {
            padding-bottom: 0.25rem;
            font-size: 1.125rem;
            color: var(--link-color);
          }
        }
      }

      &.tooltipFeedback {
        max-width: 19.25rem;
        text-align: center;
        .button {
          margin: 0;
        }
      }
    }
  }

</style>
